#! /usr/bin/python

from __future__ import division

import gobject, gtk, pango
import itertools
gtk.gdk.threads_init()
import sys, time, os, subprocess
from threading import Thread, Lock
from momail_ui import Ui
import dbus
from optparse import OptionParser

__version__ = '0.1'

########################## CONFIGURATION #######################################

not_installed_dir = os.path.dirname(os.path.realpath(__file__))
if os.path.exists(not_installed_dir + '/stuff'):
    STUFF_DIR = not_installed_dir + '/stuff'
    LOCALE_DIR = not_installed_dir + '/locale'
else:
    for directory in [sys.prefix, sys.prefix + '/local']:
        installed_root_dir = directory + '/share'
        if os.path.exists(installed_root_dir + '/momail/stuff'):
            STUFF_DIR = installed_root_dir + '/momail/stuff'
            LOCALE_DIR = installed_root_dir + '/locale'
            break

gtk.window_set_default_icon_from_file(STUFF_DIR + '/momail.svg')

########################## END OF CONFIGURATION ################################


########################## LOCALIZATION ########################################

import locale
import gettext

APP = 'momail'

gettext.install(APP, localedir=LOCALE_DIR, unicode=True)

# For gtk.Builders:
locale.bindtextdomain(APP, LOCALE_DIR)

########################## END OF LOCALIZATION #################################



def initialize_mobile():
    global fin
    global fout
    try:
        fin = open('/dev/rfcomm2', 'w')
        fout = open('/dev/rfcomm2')
    except IOError:
        # From http://blog.francispereira.com/how-to-connect-pys60-bluetooth-console-and-ubuntu-8-04 :
        subprocess.call(['hciconfig', 'reset'])
        subprocess.call(['sdptool', 'add', '--channel=2', 'SP'])
#        import bluetooth
 #       s = bluetooth.BluetoothSocket(bluetooth.RFCOMM)
  #      try:
   #         s.bind(("", 2))
    #    except:
     #       pass
      #  s.listen(2)
        rfcomm_listen = subprocess.Popen(['rfcomm', 'listen', 'rfcomm2', '2'])
        
        bus = dbus.SystemBus()
        
        bluez_manager = dbus.Interface(bus.get_object('org.bluez', '/'), 'org.bluez.Manager')
        try:
            interface_address = bluez_manager.FindAdapter('hci0')
        except:
            sorry = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_CLOSE, message_format=_("Couldn't find a bluetooth interface on this computer, exiting."))
            sorry.set_title(_("Momail: no bluetooth interface"))
            sorry.run()
            sorry.destroy()
            sys.exit()
        bluez_interface = dbus.Interface(bus.get_object('org.bluez', interface_address), 'org.bluez.Adapter')
        
        # FIXME: this function must be a method of Momail and must use the same
        # ui.
        temp_ui = Ui(APP, 'stuff/main.glade')
        temp_ui.startup_dialog.format_secondary_text(_("""For momail to work, Python For S60 and the Python Script Shell must be installed on your telephone (you can get last version at http://sourceforge.net/projects/pys60/files ).
To connect, open the Python Shell on the device and choose "Bluetooth console" from "Options" menu; then, select this computer (named %s). \nFinally, click the button "Connect" below.""") % bluez_interface.GetProperties()['Name'])
        resp = temp_ui.startup_dialog.run()

        temp_ui.startup_dialog.hide()
        if resp != 3:
            sys.exit(0)

        fin = open('/dev/rfcomm2', 'w')
        fout = open('/dev/rfcomm2')

    global rfcomm_lock
    global r

    rfcomm_lock = Lock()

    r = Reader(fout)
    r.daemon = True
    r.start()
    

class Reader(Thread):
    def __init__(self, lecture):
        Thread.__init__(self)
        self.lecture = lecture
        self.output = ['']
        self.lastread = time.time()
        
    def run(self):
        outline = ''
        import time
        while True:
            if not self.lecture:
                # The other thread is clear()ing.
                time.sleep(.1)
            c = self.lecture.read(1)
#            print c,
            self.lastread = time.time()
            if c == '\n':
                if debug:
                    fdeb.write(outline+'\n')
                    fdeb.flush()
                outline = ''
                self.output.append(outline)
            else:
                outline += c
                self.output[-1] = outline

    def clear(self):
        even = True
        while not r.output[-1].startswith('>>> '):
#            print "output", r.output
 #           print "dirty: \"%s\"" % r.output[-1]
#            global fout
 #           global fin
#            self.lecture = None
 #           fout.close()
  #          fin.close()
#            cat = subprocess.Popen(['cat', '/dev/rfcomm2'])
 #           time.sleep(.2)
  #          if cat.returncode == None:
   #             subprocess.call(['kill', str(cat.pid)])
            fin.write('\n')
            fin.flush()
#            subprocess.call(['echo > /dev/rfcomm2'], shell=True)
            time.sleep(.2)
       #     fin = open('/dev/rfcomm2')
        #    fout = open('/dev/rfcomm2', 'w')
         #   self.lecture = fout
          #  fin.write('\n')
           # time.sleep(.1)
        return
        # Other old (hopefully useless) code.
        if True:            
            fin.write('\n')
            print "flush!"
            self.lecture.flush()
            print "read"
            self.lecture.read(1)
            time.sleep(.1)
            if even:
                fin.write('\n')
            even = not even
            fin.flush()
            time.sleep(.1)


class LoaderThread(Thread):
    def __init__(self):
        Thread.__init__(self)
        self.daemon = True
        
        self.running_loaders = []
        
    def new_loader(self, store):
        new = Loader(store)
        self.running_loaders.append(new)
        return new

    def prioritize(self, loader, single=False):
        """Prioritize the loader. If "single" is True, ensure it does a step,
        then bring it back to normal priority (useful for the handshake)."""
    
        # It could be very well ended:
        if loader in self.running_loaders:
            # It isn't. Just move at the beginning of the list.

            if single:
                # Not affected by race conditions: if in the meanwhile the
                # the thread runs a step on it, it means it already was at the
                # top, so it will just leave it there.
                loader._back_to = self.running_loaders.index(loader)

            self.running_loaders.remove(loader)
            self.running_loaders.insert(0, loader)

    def run(self):
        while self.running_loaders:
            current = self.running_loaders[0]
            if not current.run_step():
                self.running_loaders.remove(current)
            try:
                back_to = current._back_to
                if back_to:
                    self.running_loaders.insert(back_to, self.running_loaders.pop())
            except AttributeError:
                pass

            current._back_to = 0

class Loader(object):
    SMS_PER_LOAD = 10
    def __init__(self, store):
        self.store = store
        self.cache = {}
        # This is for accessing the cache:
        self.lock = Lock()
        
        self.loaded = 0
        self.started = False
    
    def handshake(self):
        commands = ["import inbox;",
                    "ibx_%s = inbox.Inbox(inbox.E%s);" % (self.store.target, self.store.target),
                    "ids_%s = ibx_%s.sms_messages();" % (self.store.target, self.store.target),
                    "sms_retrieve_%s = (lambda sms_id : [getattr(ibx_%s, field)(sms_id) for field in %s])" % (self.store.target, self.store.target, Sms.orig_fields.__repr__())]
        
        self.execute("".join(commands))

        ids = self.execute('ids_%s' % self.store.target)
        self.store.ids = ids

        self.to_load = list(ids)

        self.started = True
        
    def run_step(self):
        if not self.started:
            self.handshake()
            return True
        
        if not self.to_load:
            # finished
            return False

        if self.loaded > 100:
            # He has already enough to read: let's now be efficient:
            self.SMS_PER_LOAD = 60
        
        self.load_multiple(self.to_load[:self.SMS_PER_LOAD])
        self.to_load = self.to_load[self.SMS_PER_LOAD:]
    
        return True    
    
    def load_multiple(self, ids):
#        print "retrieve", ids
        if not ids:
            return
        data_list = self.execute('[sms_retrieve_%s(sms_id) for sms_id in %s]' % (self.store.target, ids.__repr__()))
        if not data_list:
            print '[sms_retrieve_%s(sms_id) for sms_id in %s]' % (self.store.target, ids.__repr__()) , "returned", data_list
        to_add = {}
        for idx in xrange(len(ids)):
            try:
                to_add[ids[idx]] = Sms(ids[idx], data_list[idx])
            except TypeError:
                print to_add, ids, data_list, idx
                raise
            self.lock.acquire()
            self.cache.update(to_add)
            self.lock.release()
        self.loaded += len(ids)

    def execute(self, command):
        """Execute a command on the mobile."""
        # FIXME? Currently only supports single-line commands.
        rfcomm_lock.acquire()
        r.clear()
        r.output = ['']
        fin.write(command+'\n')
        fin.flush()
        if debug:
            fdebout.write(command+'\n')
            fdebout.flush()

        while True:
            if r.output and r.output[-1].startswith('>>> '):
                break
            time.sleep(.5)

        lines_back = 2
        while len(r.output) >= lines_back and not r.output[-lines_back].startswith('>>> '):
            lines_back += 1
            
#        print "Output", r.output
 #       print "gives", '\n'.join(r.output[-lines_back + 1:-1])[:-1]
            
        
        retval = '\n'.join(r.output[-lines_back + 1:-1])[:-1]
        if not retval:
            retval = 'None'
        try:
            rfcomm_lock.release()
            return eval(retval)
        except SyntaxError:
            print "error parsing \"%s\" from command \"%s\"" % (retval, command)
            sys.exit()


    def __repr__(self):
        return "<Loader %d for %s>" % (id(self), self.store.__repr__())

class Sms(object):
    orig_fields = ['content', 'time', 'address']
    def __init__(self, sms_id, data_list):
        self.id = sms_id
        self.data_list = data_list
        self.load_data()

    def load_data(self):
        self.content, self.time, self.address = self.data_list
        self.time_of_day = time.strftime('%H:%M:%S', time.localtime(self.time))
        self.date = time.strftime('%d %b %Y', time.localtime(self.time))

class Momail(object):
    folders_translations = {'Inbox' : _('Inbox'), 'Draft' : _('Draft'), 'Sent' : _('Sent'), 'Outbox' : _('Outbox')}
    # Redefining because order matters:
    folders = ['Inbox', 'Draft', 'Sent', 'Outbox']
    def __init__(self):
        self.ui = Ui(APP, STUFF_DIR + '/main.glade')
        self.stores = {}
        
        self.loader = LoaderThread()
        
        for folder in self.folders:
                self.stores[folder] = SmsStore(folder)
                self.stores[folder].loader = self.loader.new_loader(self.stores[folder])
                self.ui.notebook.append_page(self.stores[folder].ui.store, gtk.Label(self.folders_translations[folder]))
        
        self.loader.start()
        
        # The first:
        self.active = self.stores[self.folders[0]]
        self.active.show()

        self.ui.backup.connect('activate', self.backup)
        self.ui.about_button.connect('activate', self.about)
        self.ui.notebook.connect('switch-page', self.switch_page)

        self.ui.main.connect('destroy', self.quit)
        self.ui.main.show_all()
        gtk.main()

    def about(self, *args):
        self.ui.about.run()
        self.ui.about.hide()

    def switch_page(self, notebook, gpointer, page):
        if self.active.populating:
            gobject.source_remove(self.active.populating)
            self.active.populating = None

        self.active = self.stores[self.folders[page]]
        
        self.loader.prioritize(self.active.loader)
        self.active.show()

    def backup(self, *args):
        self.ui.backup_only_current.set_label(_("Backup only folder %s") % self.active.target)
        resp = self.ui.filechooser.run()
        filename = self.ui.filechooser.get_filename()
        only_current = self.ui.backup_only_current.get_active()
        self.ui.filechooser.hide()
        if resp != gtk.RESPONSE_OK:
            return
        
        if only_current:
            to_backup = [self.active]
        else:
            to_backup = [self.stores[target] for target in self.folders]

        self.backupper = gobject.timeout_add(200, self.do_backup, to_backup, filename)
        self.ui.backup_loading.run()
        resp = self.ui.backup_loading.hide()
        if resp != 3:
            gobject.source_remove(self.backupper)

    def do_backup(self, to_backup, filename):
        # We're inside the backup_loading loop!
        
        for store in to_backup:
            if not store.loaded:
                store.populate()
        
        if all([store.loaded for store in to_backup]):
            self.ui.backup_progress.set_text(_("Saving to %s") % filename)
            self.ui.backup_loading.emit('response', 3)  
        elif not all([store.loader.started for store in to_backup]):
            self.ui.backup_progress.set_text(_("Loading info"))
            for store in to_backup:
                if not store.loader.started:
                    self.loader.prioritize(store.loader, single=True)
            return True
        else:
            loaded = sum([len(store) for store in to_backup])
            to_load = sum([len(store.ids) for store in to_backup])
            self.ui.backup_progress.set_fraction( loaded /  to_load )
            self.ui.backup_progress.set_text(_("Loaded %(loaded)d of %(to_load)d") % locals())
            return True

        from xml.dom.minidom import Document
        doc = Document()
        backup_root = doc.createElement("sms-backup")
        backup_root.setAttribute("creator", "momail %s" % __version__)
        doc.appendChild(backup_root)

        for store in to_backup:
            backup_root.appendChild(store.to_xml(doc))

        fout = open(filename, 'w')
        fout.write(doc.toprettyxml())
        fout.close()

    def quit(self, *args):
        print "quit!"
        gtk.main_quit()

class SmsStore(dict):
    def __init__(self, target):
#       print 'ids "%s"' % ids_str
        self.target = target

        self.loader = Loader(self)

        self.ui = Ui(APP, STUFF_DIR + '/store.glade')
        if self.target == 'Inbox':
            # Then "To" is not a valid descriptor for the "Address" field:
            self.ui.address_descriptor.set_text(_('From:'))

        self.ids = None
        self.populating = None
        self.loaded = False
        
        self.setup_treeview()
                        
        self.ui.store.show_all()
        

    def show(self):
        if not self.populating:
            self.populating = gobject.timeout_add(200, self.populate)

    def populate(self):
    
        if self.ids == None:
#            print "no self.ids"
            msg = _("loading info")
            self.ui.status.push(self.ui.status.get_context_id(msg), msg)
            return True
        
        # This should be the only place where we risk blockage:
        self.loader.lock.acquire()
        self.update(self.loader.cache)
        new = self.loader.cache
        self.loader.cache = {}
        self.loader.lock.release()
        self.update(new)

        for sms_id in new:
            sms = new[sms_id]
            self[sms_id] = sms
            self.ui.list.insert_before(None, [sms.address, sms.content, sms.date, sms_id])
        
        msg = _("Loading (%(loaded)d/%(to_load)d)") % {'loaded': len(self), 'to_load': len(self.ids)}
       
        self.ui.status.push(self.ui.status.get_context_id(msg), msg)

        if len(self) == len(self.ids):
            self.loaded = True
            msg = _("%d messages") % len(self)
            self.ui.status.push(self.ui.status.get_context_id(msg), msg)
            self.populating = None
            return

        return True


    def to_xml(self, doc):
        # Some items may 
        self.populate()
        list_el = doc.createElement("sms-list")
        list_el.setAttribute("folder", self.target)
        
        for sms_id in self:
            sms = self[sms_id]
            sms_el = doc.createElement("sms")
            for field in Sms.orig_fields:
                sms_el.setAttribute(field, str(getattr(sms, field)))
            sms_el.setAttribute('original-id', str(sms.id))
            list_el.appendChild(sms_el)
        
        return list_el
    
    def setup_treeview(self):
        fields = ['Address', 'Preview', 'Date']
        fields_translations = ['Indirizzo', 'Anteprima', 'Data']
        for field in fields:
            renderer = gtk.CellRendererText()
            column = gtk.TreeViewColumn(field, renderer)

            column.set_resizable(True)        

            if field == 'Preview':
                renderer.set_property('ellipsize', pango.ELLIPSIZE_END)
                column.set_expand(True)
            
            self.ui.tree.append_column(column)
            column.add_attribute(renderer, 'text', fields.index(field))
        
        self.selection = self.ui.tree.get_selection()
        self.selection.connect('changed', self.show_sms)
                    
    def show_sms(self, selection=None):
        model, selection_iter = self.selection.get_selected()
        sms_id = model.get_value(selection_iter, 3)
        
        sms = self[sms_id]
        for field in ['content', 'address', 'date', 'time_of_day']:
            if hasattr(sms, field):
                    getattr(self.ui, field).set_text(getattr(sms, field))
                
    def __repr__(self):
        return "<Store %d of %s>" % (id(self), self.target)

def main():
    parser = OptionParser(usage="usage: %prog [options]", version="%prog " + __version__)
    
    parser.add_option("-d", "--debug", action="store_true", help="Output debug information (to files ./momail.log and ./momail.out.log).")
    
    (options, args) = parser.parse_args()
    global debug
    debug = options.debug
    if debug:
        global fdeb
        global fdebout
        fdeb = open('./momail.log', 'w')
        fdebout = open('./momail.out.log', 'w')

    initialize_mobile()
    smss = Momail()
    
if __name__ == '__main__':
    main()
